QCPBars Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions | Protected Static Functions
QCPBars Class Reference

A plottable representing a bar chart in a plot. More...

Inheritance diagram for QCPBars:

## Public Types
enum | WidthType

## Public Functions
| QCPBars (QCPAxis *keyAxis, QCPAxis *valueAxis)
double | width () const
WidthType | widthType () const
QCPBarsGroup * | barsGroup () const
double | baseValue () const
QCPBars * | barBelow () const
QCPBars * | barAbove () const
QCPBarDataMap * | data () const
void | setWidth (double width)
void | setWidthType (WidthType widthType)
void | setBarsGroup (QCPBarsGroup *barsGroup)
void | setBaseValue (double baseValue)
void | setData (QCPBarDataMap *data, bool copy=false)
void | setData (const QVector< double > &key, const QVector< double > &value)
void | moveBelow (QCPBars *bars)
void | moveAbove (QCPBars *bars)
void | addData (const QCPBarDataMap &dataMap)
void | addData (const QCPBarData &data)
void | addData (double key, double value)
void | addData (const QVector< double > &keys, const QVector< double > &values)
void | removeDataBefore (double key)
void | removeDataAfter (double key)
void | removeData (double fromKey, double toKey)
void | removeData (double key)
virtual void | clearData ()
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
bool | antialiasedErrorBars () const
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
bool | selectable () const
bool | selected () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setAntialiasedErrorBars (bool enabled)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual bool | addToLegend ()
virtual bool | removeFromLegend () const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual QCPRange | getKeyRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
void | getVisibleDataBounds (QCPBarDataMap::const_iterator &lower, QCPBarDataMap::const_iterator &upperEnd) const
QPolygonF | getBarPolygon (double key, double value) const
void | getPixelWidth (double key, double &lower, double &upper) const
double | getStackedBaseValue (double key, bool positive) const
Protected Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
QPen | mainPen () const
QBrush | mainBrush () const
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
void | applyErrorBarsAntialiasingHint (QCPPainter *painter) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Protected Static Functions
static void | connectBars (QCPBars *lower, QCPBars *upper)

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)
Protected Types inherited from QCPAbstractPlottable
enum | SignDomain

## Detailed Description

A plottable representing a bar chart in a plot.

To plot data, assign it with the setData or addData functions.

# Changing the appearance

The appearance of the bars is determined by the pen and the brush (setPen, setBrush). The width of the individual bars can be controlled with setWidthType and setWidth.

Bar charts are stackable. This means, two QCPBars plottables can be placed on top of each other (see QCPBars::moveAbove). So when two bars are at the same key position, they will appear stacked.

If you would like to group multiple QCPBars plottables together so they appear side by side as shown below, use QCPBarsGroup.

# Usage

Like all data representing objects in QCustomPlot, the QCPBars is a plottable (QCPAbstractPlottable). So the plottable-interface of QCustomPlot applies (QCustomPlot::plottable, QCustomPlot::addPlottable, QCustomPlot::removePlottable, etc.)

Usually, you first create an instance:

QCPBars *newBars = new QCPBars(customPlot->xAxis, customPlot->yAxis);

add it to the customPlot with QCustomPlot::addPlottable:

customPlot->addPlottable(newBars);

and then modify the properties of the newly created plottable, e.g.:

newBars->setName("Country population");
newBars->setData(xData, yData);

## Member Enumeration Documentation

enum QCPBars::WidthType

Defines the ways the width of the bar can be specified. Thus it defines what the number passed to setWidth actually means.

See Also
  setWidthType, setWidth

Enumerator
wtAbsolute | Bar width is in absolute pixels.
wtAxisRectRatio | Bar width is given by a fraction of the axis rect size.
wtPlotCoords | Bar width is in key coordinates and thus scales with the key axis range.

## Constructor & Destructor Documentation

QCPBars::QCPBars | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a bar chart which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The constructed QCPBars can be added to the plot with QCustomPlot::addPlottable, QCustomPlot then takes ownership of the bar chart.

## Member Function Documentation

QCPBars * QCPBars::barBelow | ( |  | ) | const
| inline

Returns the bars plottable that is directly below this bars plottable. If there is no such plottable, returns 0.

See Also
  barAbove, moveBelow, moveAbove

QCPBars * QCPBars::barAbove | ( |  | ) | const
| inline

Returns the bars plottable that is directly above this bars plottable. If there is no such plottable, returns 0.

See Also
  barBelow, moveBelow, moveAbove

void QCPBars::setWidth | ( | double | width | ) |

Sets the width of the bars.

How the number passed as width is interpreted (e.g. screen pixels, plot coordinates,...), depends on the currently set width type, see setWidthType and WidthType.

void QCPBars::setWidthType | ( | QCPBars::WidthType | widthType | ) |

Sets how the width of the bars is defined. See the documentation of WidthType for an explanation of the possible values for widthType.

The default value is wtPlotCoords.

See Also
  setWidth

void QCPBars::setBarsGroup | ( | QCPBarsGroup * | barsGroup | ) |

Sets to which QCPBarsGroup this QCPBars instance belongs to. Alternatively, you can also use QCPBarsGroup::append.

To remove this QCPBars from any group, set barsGroup to 0.

void QCPBars::setBaseValue | ( | double | baseValue | ) |

Sets the base value of this bars plottable.

The base value defines where on the value coordinate the bars start. How far the bars extend from the base value is given by their individual value data. For example, if the base value is set to 1, a bar with data value 2 will have its lowest point at value coordinate 1 and highest point at 3.

For stacked bars, only the base value of the bottom-most QCPBars has meaning.

The default base value is 0.

void QCPBars::setData | ( | QCPBarDataMap * | data,
|  | bool | copy = `false`
| ) |  |

Replaces the current data with the provided data.

If copy is set to true, data points in data will only be copied. if false, the plottable takes ownership of the passed data and replaces the internal data pointer with it. This is significantly faster than copying for large datasets.

void QCPBars::setData | ( | const QVector< double > & | key,
|  | const QVector< double > & | value
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in key and value tuples. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPBars::moveBelow | ( | QCPBars * | bars | ) |

Moves this bars plottable below bars. In other words, the bars of this plottable will appear below the bars of bars. The move target bars must use the same key and value axis as this plottable.

Inserting into and removing from existing bar stacking is handled gracefully. If bars already has a bars object below itself, this bars object is inserted between the two. If this bars object is already between two other bars, the two other bars will be stacked on top of each other after the operation.

To remove this bars plottable from any stacking, set bars to 0.

See Also
  moveBelow, barAbove, barBelow

void QCPBars::moveAbove | ( | QCPBars * | bars | ) |

Moves this bars plottable above bars. In other words, the bars of this plottable will appear above the bars of bars. The move target bars must use the same key and value axis as this plottable.

Inserting into and removing from existing bar stacking is handled gracefully. If bars already has a bars object below itself, this bars object is inserted between the two. If this bars object is already between two other bars, the two other bars will be stacked on top of each other after the operation.

To remove this bars plottable from any stacking, set bars to 0.

See Also
  moveBelow, barBelow, barAbove

void QCPBars::addData | ( | const QCPBarDataMap & | dataMap | ) |

Adds the provided data points in dataMap to the current data.

See Also
  removeData

void QCPBars::addData | ( | const QCPBarData & | data | ) |

This is an overloaded function. Adds the provided single data point in data to the current data.

See Also
  removeData

void QCPBars::addData | ( | double | key,
|  | double | value
| ) |  |

This is an overloaded function. Adds the provided single data point as key and value tuple to the current data

See Also
  removeData

void QCPBars::addData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | values
| ) |  |

This is an overloaded function. Adds the provided data points as key and value tuples to the current data.

See Also
  removeData

void QCPBars::removeDataBefore | ( | double | key | ) |

Removes all data points with key smaller than key.

See Also
  addData, clearData

void QCPBars::removeDataAfter | ( | double | key | ) |

Removes all data points with key greater than key.

See Also
  addData, clearData

void QCPBars::removeData | ( | double | fromKey,
|  | double | toKey
| ) |  |

Removes all data points with key between fromKey and toKey. if fromKey is greater or equal to toKey, the function does nothing. To remove a single data point with known key, use removeData(double key).

See Also
  addData, clearData

void QCPBars::removeData | ( | double | key | ) |

This is an overloaded function.

Removes a single data point at key. If the position is not known with absolute precision, consider using removeData(double fromKey, double toKey) with a small fuzziness interval around the suspected position, depeding on the precision with which the key is known.

See Also
  addData, clearData

void QCPBars::clearData | ( |  | ) |
| virtual

Removes all data points.

See Also
  removeData, removeDataAfter, removeDataBefore

Implements QCPAbstractPlottable.

double QCPBars::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See Also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractPlottable.

void QCPBars::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

void QCPBars::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implements QCPAbstractPlottable.

QCPRange QCPBars::getKeyRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data key bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

QCPRange QCPBars::getValueRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data value bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

void QCPBars::getVisibleDataBounds | ( | QCPBarDataMap::const_iterator & | lower,
|  | QCPBarDataMap::const_iterator & | upperEnd
| ) |  | const
| protected

called by draw to determine which data (key) range is visible at the current key axis range setting, so only that needs to be processed. It also takes into account the bar width.

lower returns an iterator to the lowest data point that needs to be taken into account when plotting. Note that in order to get a clean plot all the way to the edge of the axis rect, lower may still be just outside the visible range.

upperEnd returns an iterator one higher than the highest visible data point. Same as before, upperEnd may also lie just outside of the visible range.

if the bars plottable contains no data, both lower and upperEnd point to constEnd.

QPolygonF QCPBars::getBarPolygon | ( | double | key,
|  | double | value
| ) |  | const
| protected

Returns the polygon of a single bar with key and value. The Polygon is open at the bottom and shifted according to the bar stacking (see moveAbove) and base value (see setBaseValue).

void QCPBars::getPixelWidth | ( | double | key,
|  | double & | lower,
|  | double & | upper
| ) |  | const
| protected

This function is used to determine the width of the bar at coordinate key, according to the specified width (setWidth) and width type (setWidthType).

The output parameters lower and upper return the number of pixels the bar extends to lower and higher keys, relative to the key coordinate (so with a non-reversed horizontal axis, lower is negative and upper positive).

double QCPBars::getStackedBaseValue | ( | double | key,
|  | bool | positive
| ) |  | const
| protected

This function is called to find at which value to start drawing the base of a bar at key, when it is stacked on top of another QCPBars (e.g. with moveAbove).

positive and negative bars are separated per stack (positive are stacked above baseValue upwards, negative are stacked below baseValue downwards). This can be indicated with positive. So if the bar for which we need the base value is negative, set positive to false.

void QCPBars::connectBars | ( | QCPBars * | lower,
|  | QCPBars * | upper
| ) |  |
| staticprotected

Connects below and above to each other via their mBarAbove/mBarBelow properties. The bar(s) currently above lower and below upper will become disconnected to lower/upper.

If lower is zero, upper will be disconnected at the bottom. If upper is zero, lower will be disconnected at the top.

The documentation for this class was generated from the following files:

- src/plottables/plottable-bars.h
- src/plottables/plottable-bars.cpp